<template>
  <div class="header-grid">
    <div class="container">
      <div class="flex-parent parent-select-box">
        <div class="flex-item">
          <div class="selectBox">
            <cdx-combobox :menu-items="countryMenuItems" v-model:selected="appStore.currentCountry" placeholder="Select a country" />
          </div>
        </div>
        <div class="flex-item">
          <cdx-select :menu-items="appStore.years" v-model:selected="appStore.currentYear" />
        </div>
      </div>
    </div>
    <div class="card">
      <p>Active Wikimedia Projects * </p>
      <h2>{{ projectsData.length }}</h2>
    </div>
    <div class="card">
      <p>Languages with Active Wikimedia Projects *</p>
      <h2>{{ activeEditors }}</h2>
    </div>
    <div class="card">
      <p>Official Languages</p>
      <h2>{{ officialLanguages }}</h2>
    </div>
    <div class="card">
      <p>Vulnerably Endangered Languages</p>
      <h2>{{ vulnerableLanguages }}</h2>
    </div>
  </div>
  <div class="container">
    <div class="flex-parent" v-show="appStore.currentCountry !== null">
      <div class="flex-item">
        <text-table :data="projectsData"
                    :format-function="formatProjectsData"
                    :hide-columns="hideColumnsBriefProjects"
                    :column-order="columnOrderBriefProj"
                    :row-order="rowOrderBriefProj"
                    :row-order-direction="'desc'"
                     />
        <p style="font-size: smaller;">* must have at least ten average monthly editors to be listed</p>
      </div>
      <div class="flex-item">
        <text-table :data="languagesData" :format-function="formatLanguageData" :hide-columns="hideColumns" :row-order="rowOrderLanguages" :row-order-direction="'asc'"/>

      </div>
      <div class="flex-item">
        <text-table :data="endangeredData" :format-function="formatEndangeredData" :hide-columns="hideColumns" :row-order="rowOrderEndangered" :row-order-direction="'desc'"/>
        <p style="font-size: smaller;">** based on UNESCO's (2017) Atlas of Endangered Languages</p>
      </div>
    </div>
  </div>
</template>


<script setup lang="ts">
import { filterByColumn } from '@/chartPrep';
import { computed, ref, watchEffect, onMounted } from 'vue';
import { useChartStore } from '@/stores/chart';
import { useDataStore } from '@/stores/data';
import {useAppStateStore} from '@/stores/appState';

import TextTable from '@/components/TextTable.vue';
import { CdxSelect, CdxCombobox } from '@wikimedia/codex';

const appStore = useAppStateStore();
const chartStore = useChartStore();
const dataStore = useDataStore();

const languagesData: any = ref([]);
const projectsData: any = ref([]);
const endangeredData: any = ref([]);
const countryMenuItems: any = ref([]);
const hideColumns = ref(["continent", "sub_continent", "country_name"])
const hideColumnsBriefProjects = ref(['language_name'].concat(hideColumns.value))

const columnOrderBriefProj: Array<string> = ["project_name", "proportion", "average_active_editors"]
const rowOrderBriefProj: Array<string> = ["proportion"]


const rowOrderEndangered: Array<string> = ["number_of_speakers"]

const rowOrderLanguages: Array<string> = ["status"]

// use the languageData array to count the number of 'Official language' using status
const officialLanguages = computed(() => {
  return languagesData.value.filter((language: any) => language.status === 'Official language').length;
});

// use the endageredData array to count the number of 'Vulnerable' using degree_of_endangerment
const vulnerableLanguages = computed(() => {
  return endangeredData.value.filter((language: any) => language.degree_of_endangerment === 'Vulnerable').length;
});

// count the distinct number of languages in the projectsData array
const activeEditors = computed(() => {
  const languages = new Set();
  projectsData.value.forEach((project: any) => {
    languages.add(project.language_name);
  });
  return languages.size;
});

function load() {
  languagesData.value = dataStore.getStateVariable('languageData', []);
  projectsData.value = dataStore.getStateVariable('briefProjectsEdited', []);
  endangeredData.value = dataStore.getStateVariable('endangeredLanguages', []);
  countryMenuItems.value = chartStore.getCountryMenuItems();

  if (!chartStore.isEmpty(languagesData.value)) {
    languagesData.value = filterData(languagesData.value);
  }

  if (!chartStore.isEmpty(projectsData.value)) {
    projectsData.value = filterData(projectsData.value, true);
  }

  if (!chartStore.isEmpty(endangeredData.value)) {
    endangeredData.value = filterData(endangeredData.value);
  }
}

function filterData(data: any, filterYear: boolean = false) {
  if (filterYear) {
    return filterByCountry(dataStore.filterByYear(data, appStore.currentYear), appStore.currentCountry);
  }
  else {
    return filterByCountry(data, appStore.currentCountry);
  }
}

function formatLanguageData(props: any) {
  const value = props.formattedRow[props.column.field];
  if (value === 'Indigenous language') {
    return 'cell-blue';
  } else if (value === 'Co-official' || value === 'Official language') {
    return 'cell-green';
  }
  else {
    return 'cell-na';
  }
}

function formatProjectsData(props: any) {
  const value = props.formattedRow[props.column.field];
  const column = props.column.field;

  if (column === 'proportion') {

    if (value > 7) {
      return 'cell-green';
    } else if (value > 3) {
      return 'cell-blue';
    } else {
      return 'cell-red';
    }

  }

  else if (column === 'average_active_editors') {
    if (value > 75) {
      return 'cell-green';
    } else if (value > 50) {
      return 'cell-blue';
    } else {
      return 'cell-red';
    }
  }
  else {
    return 'cell-na';
  }
}

function formatEndangeredData(props: any) {
  const value = props.formattedRow[props.column.field];
  const column = props.column.field;

  if (column === 'degree_of_endangerment') {
    if (value === 'Extinct') {
      return 'cell-red';
    }
    else if (value === 'Severely endangered') {
      return 'cell-orange';
    }
    else if (value === 'Critically endangered') {
      return 'cell-brown';
    }
    else if (value === 'Vulnerable') {
      return 'cell-green';
    }
    else if (value === 'Definitely endangered') {
      return 'cell-blue';
    }
    else {
      return 'cell-na';

    }
  }
  else {
    return 'cell-na';
  }

}


function filterByCountry(data: Array<any>, country: string) {
        return filterByColumn(data, 'country_name', country);
}

watchEffect(() => {
  load();
});

onMounted( async () => {
  await dataStore.fetchAllData();
  load();
});


</script>

<style lang="scss">
@import '@/scss/_projectsandlanguages.scss';

.header-grid {
  @include header-grid;
}

.card {
  @include card;
}

.flex-parent {
  @include flex-parent;
}

.flex-item {
  @include flex-item;
}


.container {
  @include container;
}


.parent-select-box {
  @include select-box;
}


@media (max-width: 992px) {
  .flex-item {
    flex: 1 0 45%;
  }
}

@media (max-width: 768px) {
  .flex-item {
    flex: 1 0 100%;
  }
}
</style>
